#==============================================================================
# ■ Game_Party
#------------------------------------------------------------------------------
# 　パーティを扱うクラスです。所持金やアイテムなどの情報が含まれます。このクラ
# スのインスタンスは $game_party で参照されます。
#==============================================================================

class Game_Party < Game_Unit
  #--------------------------------------------------------------------------
  # ○ パーティ記憶初期化
  #--------------------------------------------------------------------------
  def pm_init
    @memory_actor = []
  end
  #--------------------------------------------------------------------------
  # ○ パーティ記憶
  #--------------------------------------------------------------------------
  def party_memory
    pm_init
    @memory_actor = @actors.clone
  end
  #--------------------------------------------------------------------------
  # ○ パーティ記憶からセット
  #--------------------------------------------------------------------------
  def party_remember
    @actors = @memory_actor.clone
    pm_init
  end
  #--------------------------------------------------------------------------
  # ○ 召喚ユニットをパーティ離脱させない(HP0でも消滅しない)
  #--------------------------------------------------------------------------
  def summon_no_remove
    $game_switches[SummonSystem::NO_REMOVE]
  end
end

#==============================================================================
# ■ Game_Interpreter
#------------------------------------------------------------------------------
# 　イベントコマンドを実行するインタプリタです。このクラスは Game_Map クラス、
# Game_Troop クラス、Game_Event クラスの内部で使用されます。
#==============================================================================

class Game_Interpreter
  #--------------------------------------------------------------------------
  # ○ パーティ記憶
  #--------------------------------------------------------------------------
  def party_memory
    $game_party.party_memory
  end
  #--------------------------------------------------------------------------
  # ○ パーティ記憶からセット
  #--------------------------------------------------------------------------
  def party_remember
    $game_party.party_remember
  end
end