#==============================================================================
# ■ Game_BattlerBase
#------------------------------------------------------------------------------
# 　バトラーを扱う基本のクラスです。主に能力値計算のメソッドを含んでいます。こ
# のクラスは Game_Battler クラスのスーパークラスとして使用されます。
#==============================================================================

class Game_BattlerBase
  #--------------------------------------------------------------------------
  # ● 定数（特徴）
  #--------------------------------------------------------------------------
  ORIGINAL_BUFF_RATE  = 0.15              # バフのレート　デフォは0.25
  #--------------------------------------------------------------------------
  # ● 通常能力値の強化／弱体による変化率取得　※再定義
  #--------------------------------------------------------------------------
  def param_buff_rate(param_id)
    @buffs[param_id] * ORIGINAL_BUFF_RATE + 1.0
  end
end

#==============================================================================
# ■ Game_Enemy
#------------------------------------------------------------------------------
# 　敵キャラを扱うクラスです。このクラスは Game_Troop クラス（$game_troop）の
# 内部で使用されます。
#==============================================================================

class Game_Enemy < Game_Battler
  #--------------------------------------------------------------------------
  # ● 能力弱体が最大の段階か否かを判定　※オーバーライド
  #--------------------------------------------------------------------------
  def debuff_max?(param_id)
    @buffs[param_id] == debuff_count
  end
  #--------------------------------------------------------------------------
  # ○ 
  #--------------------------------------------------------------------------
  def debuff_count
    enemy.note =~ /\<デバフ:(\-?\d+)\>/ ? $1.to_i : -2
  end
end