#==============================================================================
# □ Remember
#------------------------------------------------------------------------------
# 　回想用のモジュール
#==============================================================================

module Remember
  #--------------------------------------------------------------------------
  # ○ 定数
  #--------------------------------------------------------------------------
  
  ITEM = "<回想部屋>"
  OK = "<回想可能エリア>"
  SWITCH_ID = 17 #回想禁止判定スイッチ
end

#==============================================================================
# ■ Window_ItemList
#------------------------------------------------------------------------------
# 　アイテム画面で、所持アイテムの一覧を表示するウィンドウです。
#==============================================================================

class Window_ItemList < Window_Selectable
  #--------------------------------------------------------------------------
  # ● アイテムを許可状態で表示するかどうか　※エイリアス
  #--------------------------------------------------------------------------
  alias remember_enable? enable?
  def enable?(item)
    #return false if !item
    #if item.note.include?(Remember::ITEM)
    if note_check(item, Remember::ITEM)
      remember_enable?(item) && $game_party.remember_ok?
    else
      remember_enable?(item)
    end
  end
end

#==============================================================================
# ■ Game_Party
#------------------------------------------------------------------------------
# 　パーティを扱うクラスです。所持金やアイテムなどの情報が含まれます。このクラ
# スのインスタンスは $game_party で参照されます。
#==============================================================================

class Game_Party < Game_Unit
  #--------------------------------------------------------------------------
  # ○ 回想の許可状態 
  #--------------------------------------------------------------------------
  def remember_ok?
    $game_map.note.include?(Remember::OK) && can_remember?
  end
  #--------------------------------------------------------------------------
  # ○ 回想可能判定
  #--------------------------------------------------------------------------
  def can_remember?
    !$game_switches[Remember::SWITCH_ID] #&& $game_system.game_day == :day
  end
end
